hdu Bone collector(01背包)


 

Bone collector

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 51972    Accepted Submission(s): 21897


Problem Description
Many years ago , in Teddy’s hometown there was a man who was called “Bone Collector”. This man like to collect varies of bones , such as dog’s , cow’s , also he went to the grave …
The bone collector had a big bag with a volume of V ,and along his trip of collecting there are a lot of bones , obviously , different bone has different value and different volume, now given the each bone’s value along his trip , can you calculate out the maximum of the total value the bone collector can get ?


 

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, (N <= 1000 , V <= 1000 )representing the number of bones and the volume of his bag. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
 

Output
One integer per line representing the maximum of the total value (this number will be less than 2 31).
 

Sample Input
      
      
1 5 10 1 2 3 4 5 5 4 3 2 1
 

Sample Output
      
      
14
 

Author
Teddy
 


/*
  01背包问题,这种背包特点是:每种物品仅有一件,可以选择放或不放。
用子问题定义状态:即dp[i][v]表示前i件物品恰放入一个容量为v的背包可以获得的最大价值。
则其状态转移方程便是:
dp[i][v]=max{dp[i-1][v],dp[i-1][v-cost[i]]+value[i]}

注意体积为零的情况,如:
1
5 0
2 4 1 5 1
0 0 1 0 0
结果为12

*/
#include<stdio.h>
#include<string.h>
#define max(a,b) a>b?a:b
int dp[1000][1000];
int val[1000];
int wig[1000];
int main()
{
    int t;
    int m,n;
    int i,j;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        for(i=1;i<=n;i++)
            scanf("%d",&val[i]);
        for(i=1;i<=n;i++)
            scanf("%d",&wig[i]);
        memset(dp,0,sizeof(dp));//初始化操作
        for(i=1;i<=n;i++)
            for(j=0;j<=m;j++)
        {
            if(j>=wig[i])//表示第i个物品将放入大小为j的背包中
            dp[i][j]=max(dp[i-1][j],dp[i-1][j-wig[i]]+val[i]);//第i个物品放入后,那么前i-1个物品可能会放入也可能因为剩余空间不够无法放入
            else
                dp[i][j]=dp[i-1][j];//第i个物品无法放入
        }

        printf("%d\n",dp[n][m]);
    }
  return 0;
}
 <pre name="code" class="cpp">/*
  该题的第二种解法就是对背包的优化解法,当然只能对空间就行优化,时间是不能优化的。

先考虑上面讲的基本思路如何实现,肯定是有一个主循环i=1..N,每次算出来二维数组dp[i][0..V]的所有值。
那么,如果只用一个数组dp[0..V],能不能保证第i次循环结束后dp[v]中表示的就是我们定义的状态dp[i][v]呢?

dp[i][v]是由dp[i-1][v]和dp[i-1][v-c[i]]两个子问题递推而来,能否保证在推dp[i][v]时(也即在第i次主循环中推dp[v]时)能够得到dp[i-1][v]和dp[i-1][v-c[i]]的值呢?事实上,这要求在每次主循环中我们以v=V..0的顺序推dp[v],这样才能保证推dp[v]时dp[v-c[i]]保存的是状态dp[i-1][v-c[i]]的值。伪代码如下:

for i=1..N

    for v=V..0

        dp[v]=max{dp[v],dp[v-c[i]]+w[i]};

注意:这种解法只能由V--0,不能反过来,如果反过来就会造成物品重复放置!

*/
#include<stdio.h>
#include<string.h>
#define max(a,b) a>b?a:b
int dp[1000];
int val[1000];
int wig[1000];
int main()
{
    int t;
    int m,n;
    int i,j;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        for(i=1;i<=n;i++)
            scanf("%d",&val[i]);
        for(i=1;i<=n;i++)
            scanf("%d",&wig[i]);
        memset(dp,0,sizeof(dp));//初始化操作
        for(i=1;i<=n;i++)
            for(j=m;j>=0;j--)
        {
            if(j>=wig[i])//表示第i个物品将放入大小为j的背包中
            dp[j]=max(dp[j],dp[j-wig[i]]+val[i]);//第i个物品放入后,那么前i-1个物品可能会放入也可能因为剩余空间不够无法放入
            else
                dp[j]=dp[j];//第i个物品无法放入
        }

        printf("%d\n",dp[m]);
    }
  return 0;
}



 




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值